CompileUnit (groovy 3.0.9 API)

Package: org.codehaus.groovy.ast

## [Java] Class CompileUnit

- org.codehaus.groovy.ast.CompileUnit

- All Implemented Interfaces and Traits:
    NodeMetaDataHandler

      public class CompileUnit
      extends Object
      implements NodeMetaDataHandler

  Represents the entire contents of a compilation step which consists of one or more ModuleNode instances. There's one instance of this that's shared by all modules and classes compiled during a single invocation of the compiler.

  It's attached to MethodNodes and ClassNodes and is used to find fully qualified names of classes, resolve imports, and that sort of thing.

- - ### Nested Class Summary

    Nested classes
    Modifiers | Name | Description
    --- | --- | ---
    `static class` | `CompileUnit.ConstructedOuterNestedClassNode` | Represents a resolved type as a placeholder.

  - ### Constructor Summary

    Constructors
    Constructor and description
    `CompileUnit (GroovyClassLoader classLoader, CompilerConfiguration config)`
    `CompileUnit (GroovyClassLoader classLoader, CodeSource codeSource, CompilerConfiguration config)`

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `public void` | `addClass(ClassNode node)` Adds a class to the unit.
    `` | `public void` | `addClassNodeToCompile(ClassNode node, SourceUnit location)` this method actually does not compile a class.
    `` | `public void` | `addClassNodeToResolve(CompileUnit.ConstructedOuterNestedClassNode cn)` Add a constructed class node as a placeholder to resolve outer nested class further.
    `` | `public void` | `addGeneratedInnerClass(InnerClassNode icn)`
    `` | `public void` | `addModule(ModuleNode node)`
    `` | `public ClassNode` | `getClass(String name)` Returns: the ClassNode for the given qualified name or returns null if the name does not exist in the current compilation unit (ignoring the .class files on the classpath)
    `` | `public GroovyClassLoader` | `getClassLoader()`
    `` | `public List<ClassNode>` | `getClasses()` Returns: a list of all the classes in each module in the compilation unit
    `` | `public Map<String, ClassNode>` | `getClassesToCompile()`
    `` | `public Map<String, ConstructedOuterNestedClassNode>` | `getClassesToResolve()`
    `` | `public CodeSource` | `getCodeSource()`
    `` | `public CompilerConfiguration` | `getConfig()`
    `` | `public InnerClassNode` | `getGeneratedInnerClass(String name)`
    `` | `public Map<String, InnerClassNode>` | `getGeneratedInnerClasses()`
    `` | `public Map<?, ?>` | `getMetaDataMap()`
    `` | `public List<ModuleNode>` | `getModules()`
    `` | `public SourceUnit` | `getScriptSourceLocation(String className)`
    `` | `public boolean` | `hasClassNodeToCompile()`
    `` | `public Iterator<String>` | `iterateClassNodeToCompile()`
    `` | `public void` | `setMetaDataMap(Map<?, ?> metaDataMap)`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Constructor Detail

    - #### public CompileUnit(GroovyClassLoader classLoader, CompilerConfiguration config)

    - #### public CompileUnit(GroovyClassLoader classLoader, CodeSource codeSource, CompilerConfiguration config)

  - ### Method Detail

    - #### public void addClass(ClassNode node)

      Adds a class to the unit.

    - #### public void addClassNodeToCompile(ClassNode node, SourceUnit location)

      this method actually does not compile a class. It's only a marker that this type has to be compiled by the CompilationUnit at the end of a parse step no node should be be left.

    - #### public void addClassNodeToResolve(CompileUnit.ConstructedOuterNestedClassNode cn)

      Add a constructed class node as a placeholder to resolve outer nested class further.

      Parameters:
        `cn` - the constructed class node

    - #### public void addGeneratedInnerClass(InnerClassNode icn)

    - #### public void addModule(ModuleNode node)

    - #### public ClassNode getClass(String name)

      Returns:
        the ClassNode for the given qualified name or returns null if the name does not exist in the current compilation unit (ignoring the .class files on the classpath)

    - #### public GroovyClassLoader getClassLoader()

    - #### public List<ClassNode> getClasses()

      Returns:
        a list of all the classes in each module in the compilation unit

    - #### public Map<String, ClassNode> getClassesToCompile()

    - #### public Map<String, ConstructedOuterNestedClassNode> getClassesToResolve()

    - #### public CodeSource getCodeSource()

    - #### public CompilerConfiguration getConfig()

    - #### public InnerClassNode getGeneratedInnerClass(String name)

    - #### public Map<String, InnerClassNode> getGeneratedInnerClasses()

    - #### @Override public Map<?, ?> getMetaDataMap()

    - #### public List<ModuleNode> getModules()

    - #### public SourceUnit getScriptSourceLocation(String className)

    - #### public boolean hasClassNodeToCompile()

    - #### public Iterator<String> iterateClassNodeToCompile()

    - #### @Override public void setMetaDataMap(Map<?, ?> metaDataMap)